//////////////////////////////////////////////////////////////////////////
//	"sdbhttp.h"
//------------------------------------------------------------------------
//	$Id: sdbhttp.h 98 2006-04-19 06:09:44Z taro $
//////////////////////////////////////////////////////////////////////////
#ifndef	SDBHTTP_H_INCLUDED
#define	SDBHTTP_H_INCLUDED

#ifdef HAVE_CONFIG_H
#	include "config.h"
#	undef	HAVE_CONFIG_H
#endif
#include "../lib/socklib.h"

#include	<sdblib.h>
#include	"../lib/varbuf.h"

#include	<list>

// HTTP
class	SdbHttp : public SockLib
{
public:
	SQStr			host;
	SQStr			port;
	SQStr			path;

	enum	AuthType
	{
		AUTHTYPE_UNDECIDED,
		AUTHTYPE_NONE     ,
		AUTHTYPE_BASIC    ,
	};
	AuthType		authType;
	SQStr			authUser;
	SQStr			authPass;

private:
	sdb::DBDevData	devdata;
	typedef std::list<sdb::DBSmtData>	SmtList;
	SmtList			smtlist;

public:
	int				rescode;	// resule code
	SQStr			recvdata;	// Me

public:
	SdbHttp();
	~SdbHttp();

	int		SetDevData(sdb::DBDevData & devdata);
	int		AddSmtData(sdb::DBSmtData & smtdata);
	int		PostUpdate(void);
	int		PostAddDevice(sdb::DBDevData & devdata);

protected:
	int		PostData(unsigned size, const TCHAR * text);
	int		SendData(unsigned size, const TCHAR * buffer);
	int		RecvData(VarBuffer & vbuf);

public:
	static int	HtmlTimeStampEncode(VarBuffer & wbuf, SqlLib::TimeStamp & ts);
	static int	HtmlRawEncode(VarBuffer & wbuf, const TCHAR * src);
	static AuthType	GetAuthType(const TCHAR * name);
};


#endif
