//////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////

#include	"namedata.h"
#include	<string.h>

NameData::NameData()
{
	this->numItem = 0;
	this->itemTop = this->itemLast = NULL;
	this->tbl = NULL;
}


NameData::~NameData()
{
	this->ClearTable();
	if ( this->tbl != NULL )
	{
		delete [] this->tbl;
		this->tbl = NULL;
	}
}


unsigned	NameData::get_hash(SQStr & name)
{
	void	   *s;
	unsigned	hash = 0;

	if ( (s = name.GetPtrTop()) != NULL )
	{
		int			ch;

		while ( (ch = name.GetPtrChar(s)) > 0 )
		{
			hash = hash + ch * 31;
			s =  name.GetPtrNext(s);
		}
	}
	return hash & (this->hashMax - 1);
}

void	NameData::attach(NameItem * item)
{
	NameItem	  **pitem;

	if ( item == NULL )
		return;
	pitem = this->tbl + this->get_hash(item->name);

	// Xgo^
	item->list.next = NULL;
	if ( (item->list.prev = this->itemLast) != NULL )
		this->itemLast->list.next = item;
	else
		this->itemTop = item;
	this->itemLast = item;

	// nbVo^
	item->hash.prev = NULL;
	if ( (item->hash.next = *pitem) != NULL )
		(*pitem)->hash.prev = item;
	*pitem = item;

	this->numItem++;
}

void	NameData::detach(NameItem * item)
{
	NameItem	  **pitem;

	if ( item == NULL )
		return;
	pitem = this->tbl + this->get_hash(item->name);

	// Xg珜O
	if ( item->list.prev != NULL )
		item->list.prev->list.next = item->list.next;
	else
		this->itemTop = item->list.next;

	if ( item->list.next != NULL )
		item->list.next->list.prev = item->list.prev;
	else
		this->itemLast = item->list.prev;

	// nbVe[u珜O
	if ( item->hash.prev != NULL )
		item->hash.prev->hash.next = item->hash.next;
	else
		*pitem = item->hash.next;

	if ( item->hash.next != NULL )
		item->hash.next->hash.prev = item->hash.prev;

	this->numItem--;

}

int		NameData::CreateTable(unsigned bits)
{
	unsigned		i;

	if ( this->tbl != NULL )
		return -1;
	this->hashBits = bits;
	this->hashMax  = 1 << bits;
	if ( (this->tbl = new NameItem * [this->hashMax]) == NULL )
		return -1;
	for ( i = 0; i < this->hashMax; i++ )
		this->tbl[i] = NULL;
	return 0;
}

void	NameData::ClearTable(void)
{
	unsigned		i;
	NameItem	   *item, *item_next;

	item = this->itemTop;
	while ( item != NULL )
	{
		item_next = item->list.next;
	//	if ( item->data )
	//		delete [] item->data;
		delete item;
		item = item_next;
	}
	this->itemTop = this->itemLast = NULL;

	if ( this->tbl != NULL )
	{
		for ( i = 0; i < this->hashMax; i++ )
			this->tbl[i] = NULL;
	}

	this->numItem = 0;
}

int		NameData::SetItem(NameItem * item)
{
	if ( this->tbl == NULL )
	{
		if ( this->CreateTable() < 0 )
			return -1;
	}
	this->attach(item);
	return 0;
}

NameItem *		NameData::GetItem(SQStr & name)
{
	NameItem	   *item, **pitem;

	if ( this->tbl == NULL || this->numItem == 0 )
		return NULL;
	pitem = this->tbl + this->get_hash(name);
	for ( item = *pitem; item != NULL; item = item->hash.next )
	{
		if ( _tcscmp(name.GetText(), item->name.GetText()) == 0 )
			break;
		
	}
	return item;
}

NameItem *		NameData::EnumItem(NameItem * item)
{
	if ( item != NULL )
		item = item->list.next;
	else
		item = this->itemTop;
	return item;
}

