//////////////////////////////////////////////////////////////////////////
//	"namedata.h"
//------------------------------------------------------------------------
//	$Id: namedata.h 17 2006-03-04 03:33:26Z taro $
//////////////////////////////////////////////////////////////////////////
#ifndef	NAMEDATA_H_INCLUDED
#define	NAMEDATA_H_INCLUDED

#if	defined(SDBCTL) || defined(LINUX)
# include	"sqstr.h"
#else
# include	<sqstr.h>
#endif

class	NameData;
class	NameItem;

class NameItem
{
friend class	NameData;
protected:
	struct List_tag
	{
		NameItem   *next, *prev;
	};
	struct List_tag	list;
	struct Hash_tag
	{
		NameItem   *next, *prev;
	};
	struct Hash_tag	hash;
public:

	NameItem() {}
	virtual ~NameItem() {}
	SQStr			name;
//	unsigned		type;
//	unsigned		size;
//	void		   *data;
};

class	NameData
{
public:
	enum namedata_enum
	{
		DEFAULT_HASH_BITS = 4,
	};

private:
	unsigned			hashBits;
	unsigned			hashMax;
	unsigned			numItem;
	NameItem		   *itemTop;
	NameItem		   *itemLast;
	NameItem		  **tbl;

	unsigned			get_hash(SQStr & name);
	void				attach(NameItem * item);
	void				detach(NameItem * item);

public:
	NameData();
	virtual ~NameData();

	int				CreateTable(unsigned bits = DEFAULT_HASH_BITS);
	void			ClearTable(void);
	int				SetItem(SQStr & name, unsigned type, unsigned size, void * data);
	int				SetItem(NameItem * item);
	NameItem *		GetItem(SQStr & name);
	NameItem *		EnumItem(NameItem * item);
};

#endif
