//////////////////////////////////////////////////////////////////////////
//	"pgresult.cpp"
//------------------------------------------------------------------------
//	$Id: pgresult.cpp 4 2006-03-01 22:26:13Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<stdlib.h>
#include	"pglib.h"

//////////////////////////////////////////////////////////////////////////
//	Result

PgLib::Result::Result()
{
	if ( (this->p = new srep) == NULL )
		throw;
}

PgLib::Result::~Result()
{
	if ( this->p != NULL )
	{
		if ( --(this->p->ref) == 0 )
		{
			this->Clear();
			delete this->p;
			this->p = NULL;
		}
	}
}

PgLib::Result &		PgLib::Result::operator = (PgLib::Result & res)
{
	if ( res.p == NULL )
	{
		if ( (res.p = new srep) == NULL )
			throw;
	}
	++(res.p->ref);
	if ( this->p != NULL )
	{
		if ( --(this->p->ref) == 0 )
		{
			this->Clear();
			delete this->p;
			this->p = NULL;
		}
	} else
	{
		if ( (this->p = new srep) == NULL )
			throw;	// error
	}
	this->p = res.p;
	return *this;
}

PgLib::Result &		PgLib::Result::operator = (libpq::PGresult * pgres)
{
	if ( this->p != NULL )
	{
		if ( this->p->ref > 1 )
		{
			--(this->p->ref);
			this->p = new srep;
			if ( this->p == NULL )
			{	// error
				return *this;
			}
		} else
			this->Clear();
	} else
	{
		if ( (this->p = new srep) == NULL )
			throw;
	}
	this->p->pg_result = pgres;
	return *this;
}

bool		operator == (const PgLib::Result & res1, const PgLib::Result & res2)
{
	if ( res1.p == res2.p || res1.GetResult() == res2.GetResult() )
		return true;
	return false;
}

bool		operator == (const PgLib::Result & res1, const libpq::PGresult * pgres2)
{
	if ( res1.GetResult() == pgres2 )
		return true;
	return false;
}

void	PgLib::Result::Clear(void)
{
	if ( this->p != NULL && this->p->pg_result != NULL )
	{
		libpq::PQclear(this->p->pg_result);
		this->p->pg_result = NULL;
	}
}

