//////////////////////////////////////////////////////////////////////////
//	"test.cpp"
//------------------------------------------------------------------------
//	$Id: test.cpp 4 2006-03-01 22:26:13Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<stdlib.h>
#include	"pglib.h"

int		main(int argc, char ** argv)
{
	static char		*conn_param = "host=venom dbname=discdb user=discdb password=DDB6809S";
	PgLib			pglib;
	PgLib::Result	res;
	const char		*sql = NULL, *query = NULL;
	int				i, xmax, ymax, x, y;
	int				retcode;
	struct FTypeTbl : public PgLib::PgTypeItem
	{
		int			fsize;
	} * ftype_tbl;

	printf("***** libpq test program *****\n");
	for ( i = 1; i < argc; i++ )
	{
		const char	*s;

		s = argv[i];
		if ( sql == NULL )
			sql = s;
	}

	try
	{
		if ( pglib.Connectdb(conn_param) < 0 || pglib.GetStatus() != CONNECTION_OK )
		{
			fprintf(stderr, "Connection to database '%s' failed.\n", pglib.GetDb());
			fprintf(stderr, "%s", pglib.GetErrorMessage());
			throw -1;
		}

		printf("pglib.SsetClientEncodingN\n");
		if ( pglib.SetClientEncoding("SJIS") < 0 )
		{
			fprintf(stderr, "pglib.SetClientEncording error!\n");
			throw -1;
		}

		printf("BEGIN\n");
		if ( pglib.Exec(res, "BEGIN") < 0 || res.GetStatus() != PgLib::PGRES_COMMAND_OK )
		{
			fprintf(stderr, "BEGIN command failed: %s", pglib.GetErrorMessage());
			throw -1;
		}
		res.Clear();

		query = "SELECT * FROM anime_file WHERE file_name ILIKE '%%'";
		printf("%s\n", query);
		if ( pglib.Exec(res, query) < 0 || res.GetStatus() != PgLib::PGRES_TUPLES_OK )
		{
			fprintf(stderr, "%s: %s", query, pglib.GetErrorMessage());
			throw -1;
		}

		if ( (xmax = res.GetFields()) > 0 )
		{
			if ( (ftype_tbl = new FTypeTbl[xmax]) == NULL )
			{
				fprintf(stderr, "Memory allocation error!\n");
				throw -1;
			}

			for ( x = 0; x < xmax; x++ )
			{
				const char			*name;
				int					fsize, fmod;
				PgLib::Oid			oid;
				const char			*ftype_name;
				PgLib::PgTypeItem	*pgitem;

				name  = res.GetFname(x);
				oid   = res.GetFtype(x); ftype_tbl[x].oid = oid;
				fsize = res.GetFsize(x);
				fmod  = res.GetFmod(x);
				if ( (pgitem = pglib.GetPgType(oid)) != NULL )
				{
					ftype_name = pgitem->name;
				} else
					ftype_name = "(NULL)";
				ftype_tbl[x].fsize = fsize;
				if ( name != NULL )
					printf("%i:%s oid:%u %s (%d:%d)\n", x, name, oid, ftype_name, fsize, fmod);
			}
			printf("\n");

			if ( (ymax = res.GetTuples()) > 0  )
			{
				for ( y = 0; y < ymax; y++ )
				{
					for ( x = 0; x < xmax; x++ )
					{
						int		length;

						length = res.GetLength(y, x);
						printf("\t(%d)", length);
						if ( res.GetIsNull(y, x)  )
						{
							printf("NUL");
						} else
						{
							const char	*fval;

							fval = res.GetValue(y, x);
							printf("%s", fval);
						}
					}
					printf("\n");
				}
			}
		}
		res.Clear();

		/* end the transaction */
		printf("END\n");
		pglib.Exec(res, "END");
		res.Clear();
	} catch(int code) { retcode = code;	}
	pglib.Finish();
	printf("finish\n");

	return 0;
}


