//////////////////////////////////////////////////////////////////////////
//	"reganalys.cpp"
//------------------------------------------------------------------------
//	$Id: reganalys.cpp 169 2006-05-06 03:10:01Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"reganalys.h"
#include	<stdlib.h>
#include	<math.h>
#if	defined(WIN32)
# include	<windows.h>
# include	<tchar.h>
#else
#endif

#if	0 // defined(_DEBUG) && defined(WIN32)
#include	<stdio.h>
#	define	DBG_PRINTF(msg_)	_tprintf msg_
#else
#	define	DBG_PRINTF(msg_)
#endif

RegAnalys::RegAnalys()
{
	this->num = 0;
	this->x   = NULL;
	this->y   = NULL;

	return;
}

RegAnalys::~RegAnalys()
{
	if ( this->y != NULL )
		delete [] this->y;
	if ( this->x != NULL )
		delete [] this->x;
	return;
}


void	RegAnalys::ClearResult(void)
{
	this->a = 0.0;
	this->b = 0.0;
	this->std_devi = 0.0;
	this->devi = 0.0;
	this->r2 = 0.0;
	this->r  = 0.0;
	this->xmin = 0.0;
	this->xmax = 0.0;
	this->xdis = 0.0;
	this->xave = 0.0;
	this->ymin = 0.0;
	this->ymax = 0.0;
	this->ydis = 0.0;
	this->yave = 0.0;
	this->cv = 0.0;

	return;
}

int		RegAnalys::SetDataNum(unsigned num)
{
	if ( num == 0 )
		return -1;
	if ( this->x != NULL )
		delete [] this->x;
	if ( this->y != NULL )
		delete [] this->y;
	this->num = num;
	this->x = new XValue [this->num];
	this->y = new YValue [this->num];
	if ( this->x == NULL || this->y == NULL )
		return -1;
	for ( num = 0; num < this->num; num++ )
	{
		this->x[num] = 0.0;
		this->y[num] = 0.0;
	}

	return 0;
}

int		RegAnalys::Analys(void)
{
	Value		sx, sy, sx2, sy2, sxy, sxxyy;
	Value		m;
	unsigned	i;

	if ( this->num < 2 
	  || this->x == NULL
	  || this->y == NULL )
		return -1;

	sx = 0.0;
	sy = 0.0;
	sxy = 0.0;
	sx2 = 0.0;
	sy2 = 0.0;
	sxxyy = 0.0;
	for ( i = 0; i < this->num; i++ )
	{
		sx = sx + this->x[i];
		sy = sy + this->y[i];
		sxy = sxy + this->x[i] * this->y[i];
		sx2 = sx2 + pow(this->x[i], 2.0);
		sy2 = sy2 + pow(this->y[i], 2.0);
	}

	// őAŏ߂
	this->xmax = this->x[0];
	this->ymax = this->y[0];
	this->xmin = this->x[0];
	this->ymin = this->y[0];
	for ( i = 1; i < this->num; i++ )
	{
		if ( this->xmax < this->x[i] )
			this->xmax = this->x[i];
		if ( this->ymax < this->y[i] )
			this->ymax = this->y[i];
		if ( this->xmin > this->x[i] )
			this->xmin = this->x[i];
		if ( this->ymin > this->y[i] )
			this->ymin = this->y[i];
	}

	this->xave = sx / (Value)this->num;
	this->yave = sy / (Value)this->num;
	for ( i = 0; i < this->num; i++ )
	{
		sxxyy = sxxyy + (this->x[i] - this->xave) * (this->y[i] - this->yave);
	}
	this->a = ((Value)this->num * sxy - sx * sy) / ((Value)this->num * sx2 - pow(sx,2.0));
	DBG_PRINTF((TEXT("a = %f\n"), this->a));
	this->b = (sx2 * sy - sxy * sx) / ((Value)this->num * sx2 - pow(sx,2.0));
	DBG_PRINTF((TEXT("b = %f\n"), this->b));
	this->std_devi = sqrt( (sy2 - this->b * sy - this->a * sxy) / (Value)this->num);
	DBG_PRINTF((TEXT("Aɑ΂ϐy̕W΍ %f\n"), this->std_devi));
	this->devi = sqrt((sy2 - (Value)this->num * pow(this->yave,2.0) - this->a * sxxyy) / (Value)this->num);
	m = ((sx2 - (Value)this->num * pow(this->xave,2.0)) * (sy2 - (Value)this->num * pow(this->yave,2.0)));
	if ( m != 0.0 )
	{
		this->r2 = pow(sxxyy,2.0) / m;
		DBG_PRINTF((TEXT("pow(r,2) = %f\n"), this->r2));
		this->r  =  sxxyy / sqrt(m);
		DBG_PRINTF((TEXT("r = %f\n"), this->r));
	}
	DBG_PRINTF((TEXT("x̕ %f\n"), this->xave));
	this->xdis = sx2 / (Value)this->num - pow(this->xave,2.0);
	DBG_PRINTF((TEXT("x̕U %fAW΍ %f\n"), this->xdis, sqrt(this->xdis)));
	DBG_PRINTF((TEXT("y̕ %f\n"), this->yave));
	this->ydis = sy2 / (Value)this->num - pow(this->yave,2.0);
	DBG_PRINTF((TEXT("y̕U %fAW΍ %f\n"), this->ydis, sqrt(this->ydis)));
	if ( this->yave != 0.0 )
	{
		this->cv = sqrt(this->ydis) / this->yave;
		DBG_PRINTF((TEXT("ϓW(y΍^y) %f\n"), this->cv));
	}

	return 0;
}


