//////////////////////////////////////////////////////////////////////////
//	"sqpath.cpp"
//------------------------------------------------------------------------
//	$Id: sqpath.cpp 39 2006-03-07 03:32:45Z taro $

#include	"sqpath.h"

TCHAR		SQPath::delimBuf[32] = SQPATH_DEFAULT_DELIM;

SQPath::SQPath()
{
	if ( delimBuf[0] == '\0' )
		::_tcscpy(delimBuf, SQPATH_DEFAULT_DELIM);
	this->delim = delimBuf;
	return;
}

SQPath::~SQPath()
{
	return;
}

SQStr &		SQPath::AddPath(SQStr & str)
{
	SQStr		s1, s2;
	unsigned	len = 0, size = 0, buflen;
	void	   *buf;
	void	   *s, *d;

	s1 = *this;
	s2.ChangeChcode(str, this->GetChcode());
	buflen = (this->GetLength() + s2.GetLength() + 8) * sizeof(wchar_t);
	if ( (buf = new BYTE [buflen]) == NULL )
	{
		this->error = SQERR_OUT_OF_MEMORY;
RET_NULL:
		this->SetText(TEXT(""));
		return *this;
	}
	d = buf;
	if ( (s = s1.GetPtrTop()) != NULL )
	{
		int		ch, lastch = 0;

		while ( (ch = s1.GetPtrChar(s)) >= 0 )
		{
			d = this->PutPtrChar(d, ch, &size, &len);
			lastch = ch;
			s = s1.GetPtrNext(s);
		}
		if ( this->IsDelim(lastch) == FALSE )
			d = this->PutPtrChar(d, this->GetDelimCh(), &size, &len);
	}
	if ( (s = s2.GetPtrTop()) != NULL )
	{
		int			ch;

		while ( (ch = s2.GetPtrChar(s)) >= 0 )
		{
			if ( this->IsDelim(ch) == FALSE )
				break;
			s = s2.GetPtrNext(s);
		}
		while ( (ch = s2.GetPtrChar(s)) >= 0 )
		{
			d = this->PutPtrChar(d, ch, &size, &len);
			s = s2.GetPtrNext(s);
		}
	}
	this->PutPtrChar(d, 0, &size);
	if ( this->TransferToBuffer( size, buf, len, this->GetChcode()) < 0 )
	{
		delete [] (BYTE *)buf;
		goto RET_NULL;
	}
	delete [] (BYTE *)buf;
	return *this;
}


//////////////////////////////////////////////////////////////////////////
//	pXfBNgo
//------------------------------------------------------------------------
//	ex.	A:/DIR/filename		A:/DIR
//		A:/filename			A:/
//		A:filename			A:.
//		/DIR/filename		/DIR
//		filename			.
//------------------------------------------------------------------------
//	Modify	2006.03.07

SQStr &	SQPath::GetDnam(SQStr & str)
{
	SQStr		s2;
	void	   *s, *t = NULL, *d;
	void	   *buf = NULL;
	int			ch;
	unsigned	len = 0, size = 0;
	enum		RetCode { RET_NORMAL, RET_ERROR };
	RetCode		retcode = RET_NORMAL;

	if ( str.GetLength() == 0 )
		retcode = RET_ERROR;

	if ( retcode == RET_NORMAL )
	{
		s2.ChangeChcode(str, this->GetChcode());

		// ':' ܂ '\\' ̈ʒu𒲂ׂ
		if ( (s = s2.GetPtrTop()) != NULL )
		{
			while ( (ch = s2.GetPtrChar(s)) >= 0 )
			{
				if ( ch == ':' )
				{
					t = s;
				} else if ( this->IsDelim(ch) )
				{
					ch = this->GetDelimCh();
					t = s;
				}
				s = s2.GetPtrNext(s);
			}
		}
		if ( (buf = new BYTE [(s2.GetLength()+1) * sizeof(wchar_t)]) == NULL )
		{
			this->error = SQERR_OUT_OF_MEMORY;
			retcode = RET_ERROR;
		}
	}
	if ( retcode == RET_NORMAL && buf != NULL )
	{
		d = buf;
		if ( t == NULL )
		{	// Jg
			d = this->PutPtrChar(d, '.', &size, &len);
		} else
		{
			if ( (s = s2.GetPtrTop()) != NULL )
			{
				int		lastch = 0;

				while ( (ch = s2.GetPtrChar(s)) >= 0 )
				{
					if ( s == t )	// ŌɌ ':' ܂ '\\' ̈ʒu
					{
						if ( ch == ':' )
						{
							d = this->PutPtrChar(d, ':', &size, &len);
							d = this->PutPtrChar(d, '.', &size, &len);
						} else // ch == '\\'
						{
							if ( len == 0 )
							{	// "."
								d = this->PutPtrChar(d, this->GetDelimCh(), &size, &len);
							} else if ( len == 2 && lastch == ':' )	// ex. "A:"
							{
								d = this->PutPtrChar(d, this->GetDelimCh(), &size, &len);
							}
						}
						break;
					}
					d = this->PutPtrChar(d, ch, &size, &len);
					lastch = ch;
					s = s2.GetPtrNext(s);
				}
			}
		}
		this->PutPtrChar(d, 0, &size);
		if ( this->TransferToBuffer( size, buf, len, this->GetChcode()) < 0 )
			retcode = RET_ERROR;
	}
	if ( buf != NULL )
		delete [] (BYTE *)buf;

	switch ( retcode )
	{
	case RET_ERROR:
		this->SetText(TEXT(""));
		break;
	}

	return *this;
}

//////////////////////////////////////////////////////////////////////////
//	t@Co
//	擪Ō̃sIh̒O܂Ŏo
//------------------------------------------------------------------------
//	ex.	filename.sub -> filename
//------------------------------------------------------------------------
//	Modify	2006.03.07

SQStr & 	SQPath::GetFn(SQStr & str)
{
	SQStr		s2;
	enum		RetCode { RET_NORMAL, RET_SKIP, RET_ERROR };
	RetCode		retcode = RET_NORMAL;

	if ( str.GetLength() == 0 )
		retcode = RET_ERROR;

	if ( retcode == RET_NORMAL )
	{
		void	   *p, *s, *d;
		void	   *buf = NULL;
		unsigned	len = 0, size = 0;
		int			ch, n = 0, tmp[4];

		s2.ChangeChcode(str, this->GetChcode());
		p = NULL;	// Add 2003.05.02 BugFix
		if ( (s = s2.GetPtrTop()) != NULL )
		{
			while ( (ch = s2.GetPtrChar(s)) >= 0 )
			{
				if ( n < 4 )
					tmp[n++] = ch;
				if ( ch == TEXT('.') )
					p = s;
				if ( p != NULL && this->IsDelim(ch) )	// 2002.05.20: '.'ɋؕΊgqƂ݂͂ȂȂ
				{
					p = NULL;
					n = 0;
				}
				s = s2.GetPtrNext(s);
			}
		}
		if ( p == NULL )// gq͂Ȃ
			retcode = RET_SKIP;

		if ( retcode == RET_NORMAL )
		{
			if ( (n == 1 && tmp[0] == TEXT('.'))
			  || (n == 2 && tmp[0] == TEXT('.') && tmp[1] == TEXT('.')) )
			{
				retcode = RET_SKIP;
			}
		}
		if ( retcode == RET_NORMAL )
		{
			// gq'.'̒O܂Őݒ
			if ( (buf = new BYTE [(s2.GetLength()+1) * sizeof(wchar_t)]) == NULL )
			{
				this->error = SQERR_OUT_OF_MEMORY;
				retcode = RET_ERROR;
			}
		}
		if ( retcode == RET_NORMAL && buf != NULL )
		{
			d = buf;
			if ( (s = s2.GetPtrTop()) != NULL )
			{
				while ( (ch = s2.GetPtrChar(s)) >= 0 && s < p )
				{
					d = this->PutPtrChar(d, ch, &size, &len);
					s = s2.GetPtrNext(s);
				}
			}
			this->PutPtrChar(d, 0, &size);
			if ( this->TransferToBuffer( size, buf, len, this->GetChcode()) < 0 )
				retcode = RET_ERROR;
		}
		if ( buf != NULL )
			delete [] (BYTE *)buf;
	}
	switch ( retcode )
	{
	case RET_SKIP:
		this->SetText(s2);
		break;
	case RET_ERROR:
		this->SetText(TEXT(""));
		break;
	}
	return *this;
}

//////////////////////////////////////////////////////////////////////////
//	pXt@Co
//------------------------------------------------------------------------
//	Modify 2006.03.07

SQStr &		SQPath::GetFnam(SQStr & str)
{
	SQStr		s2;
	enum		RetCode { RET_NORMAL, RET_ERROR };
	RetCode		retcode = RET_NORMAL;

	if ( str.GetLength() == 0 )
		retcode = RET_ERROR;

	if ( retcode == RET_NORMAL )
		s2.ChangeChcode(str, this->GetChcode());

	if ( retcode == RET_NORMAL )
	{
		void		   *buf = NULL;
		void			*p, *p_top;
		struct ch_tag
		{
			int			ch;
			void		*p;
		};
		ch_tag			cht[4];
		unsigned		i;
		int				ch;

		p_top = p = s2.GetPtrTop();
		for ( i = 0; i < sizeof(cht)/sizeof(*cht); i++ )
		{
			cht[i].p  = p;
			cht[i].ch = s2.GetPtrChar(p);
			p = s2.GetPtrNext(p);
		}
		ch = cht[0].ch;
		if ( ((ch >= TEXT('A') && ch <= TEXT('Z')) || (ch >= TEXT('a') && ch <= TEXT('z'))) && cht[1].ch == TEXT(':')  )
		{	// hCu
			p_top = cht[2].p;
		}
		if ( ch == TEXT('.') )
		{
			if ( cht[1].ch == TEXT('.') && this->IsDelim(cht[2].ch) )	/* "../" */
			{
				p_top = cht[2].p;
			} else if ( this->IsDelim(cht[1].ch) )			/* "./" */
			{
				p_top = cht[1].p;
			}
		}

		if ( (buf = new BYTE [(s2.GetLength()+8) * sizeof(wchar_t)]) == NULL )
		{
			this->error = SQERR_OUT_OF_MEMORY;
			retcode = RET_ERROR;
		}

		if ( retcode == RET_NORMAL && buf != NULL )
		{
			void		*s;
			void		*d;
			unsigned	f_len = 0, f_size = 0;
			BOOL		next_ftop = TRUE;

			d = buf;
			s = p_top;
			while ( (ch = s2.GetPtrChar(s)) >= 0 )
			{
				if ( this->IsDelim(ch) )
				{
					next_ftop = TRUE;
				} else
				{
					if ( next_ftop != FALSE )
					{
						d = buf;
						f_len = 0;
						f_size = 0;
						next_ftop = FALSE;
					}
					d = s2.PutPtrChar(d, ch, &f_size, &f_len);
				}
				s = s2.GetPtrNext(s);
			}
			d = s2.PutPtrChar(d, 0, &f_size, NULL);
			if ( this->TransferToBuffer( f_size, buf, f_len, this->GetChcode()) < 0 )
				retcode = RET_ERROR;
		}
		if ( buf != NULL )
			delete [] (BYTE *)buf;
	}
	switch ( retcode )
	{
	case RET_ERROR:
		this->SetText(TEXT(""));
		break;
	}
	return *this; //(fn);
}

//////////////////////////////////////////////////////////////////////////
//	gqo
//	Ō̃sIh̕o
//------------------------------------------------------------------------
//	ex.	filename.sub -> sub

SQStr &		SQPath::GetSn(SQStr & str)
{
	SQStr		s2;
	enum		RetCode { RET_NORMAL, RET_ERROR };
	RetCode		retcode = RET_NORMAL;

	if ( str.GetLength() == 0 )
		retcode = RET_ERROR;

	if ( retcode == RET_NORMAL )
	{
		void	   *p, *s, *d;
		void	   *buf = NULL;
		unsigned	len = 0, size = 0;
		int			ch, n = 0, tmp[4];

		s2.ChangeChcode(str, this->GetChcode());
		p = NULL;	// Add 2003.05.02 BugFix
		if ( (s = s2.GetPtrTop()) != NULL )
		{
			while ( (ch = s2.GetPtrChar(s)) >= 0 )
			{
				if ( n < 4 )
					tmp[n++] = ch;
				if ( ch == TEXT('.') )
					p = s;
				if ( p != NULL && this->IsDelim(ch) )	// 2002.05.20: '.'ɋ؂蕶ΊgqƂ݂͂ȂȂ
				{
					p = NULL;
					n = 0;
				}
				s = s2.GetPtrNext(s);
			}
		}
		if ( p == NULL )	// gq͂Ȃ
			retcode = RET_ERROR;

		if ( retcode == RET_NORMAL )
		{
			if ( (n == 1 && tmp[0] == TEXT('.'))
			  || (n == 2 && tmp[0] == TEXT('.') && tmp[1] == TEXT('.')) )
				retcode = RET_ERROR;
		}
		// gqݒ
		if ( retcode == RET_NORMAL )
		{
			if ( (buf = new BYTE [(s2.GetLength()+1) * sizeof(wchar_t)]) == NULL )
			{
				this->error = SQERR_OUT_OF_MEMORY;
				retcode = RET_ERROR;
			}
		}
		if ( retcode == RET_NORMAL && buf != NULL )
		{
			d = buf;
			s = p;
			while ( (ch = s2.GetPtrChar(s)) >= 0 )
			{
				d = this->PutPtrChar(d, ch, &size, &len);
				s = s2.GetPtrNext(s);
			}
			this->PutPtrChar(d, 0, &size);
			if ( this->TransferToBuffer( size, buf, len, this->GetChcode()) < 0 )
				retcode = RET_ERROR;
		}
		if ( buf != NULL )
			delete [] (BYTE *)buf;
	}
	switch ( retcode )
	{
	case RET_ERROR:
		this->SetText(TEXT(""));
		break;
	}
	return *this;
}
