//////////////////////////////////////////////////////////////////////////
//	"varbuf.h"
//------------------------------------------------------------------------
//	$Id: varbuf.h 87 2006-03-30 09:24:05Z taro $
#ifndef	VARBUF_H_INCLUDED
#define	VARBUF_H_INCLUDED

#if	defined(WIN32)
# include	<windows.h>
# include	<tchar.h>
//# include	"iscrwbuf.h"
#else
# include	"../linux/defs.h"
# include	<stdlib.h>
# include	<string.h>
#endif

//class	ReadBuffer;

//////////////////////////////////////////////////////////////////////////
//	VarBuffer

class	VarBuffer			// oAuobt@
{
public:
	enum varbuffer_enum
	{
		LINE_BUFFER_SIZE = 512,
		RES_NOERROR = 0,
		RES_ERROR   = -1,
		RES_EOF     = -2,
		RES_FUNCERR = -3,
	};

public:
	unsigned	buffersize;
	unsigned	validsize;
	void	   *buffer;

	VarBuffer();
	virtual ~VarBuffer();
	void		Clear(void);
	int			Add(unsigned size, const void * data);
	int			AddChar(int ch);
	int			AddText(const TCHAR * text) { return this->Add((unsigned)_tcslen(text), text); }
	int			Printf(const TCHAR * form, ... );
	TCHAR *		GetText(void) const { return (TCHAR *)this->buffer; }
	unsigned	GetSize(void) const { return this->validsize; }
	unsigned	GetLength(void) { return this->validsize > 0 && ((TCHAR *)this->buffer)[this->validsize - 1] == TEXT('\0') ? this->validsize - 1 : this->validsize; }

public:
	const TCHAR	   *p;
	unsigned		len;
	unsigned		pos;
	unsigned		ln, cn;

	int			SetBuffer(void);
	int			SetBuffer(unsigned len, const TCHAR * text);
	TCHAR *		GetCurPtr(void);
	int			IsEnd(void);
	int			GetChar(void);
	int			UnGetChar(int ch);
	int			SkipSpace(void);
	int			GetWord(VarBuffer & word);
	int			GetLine(VarBuffer & line);
	static int	IsSpace(int ch);
	static int	IsNameTopChar(int ch);
	static int	IsNameChar(int ch);
	int			GetString(VarBuffer & str, int term);

	//////////////////////////////////////////////////////////////////////
	// Additional Library
public:
	static unsigned 	GetBase64Char(unsigned b);
	static int			Base64Encode(unsigned size, const void * buffer, VarBuffer & wbuf, unsigned maxlen = 0);

};

#endif
