//////////////////////////////////////////////////////////////////////////
//	"sdbctl.h"
//------------------------------------------------------------------------
//	$Id: sdbctl.h 155 2006-05-03 11:39:45Z taro $
//////////////////////////////////////////////////////////////////////////
#ifndef	SDBCTL_H_INCLUDED
#define	SDBCTL_H_INCLUDED

#include	<sdblib.h>
#if	defined(SDBCTL) || defined(LINUX)
# include	"../lib/sqpath.h"
#else
# include	<sqpath.h>
#endif

#define	SDBCTL_VERSION	SDB_GENERAL_VERSION
#define	SDBCTL_TITLE	TEXT("***** sdbctl - SDB control tool : ") SDBCTL_VERSION TEXT(" *****")

class	SdbLib;
class	ScrLib;
class	SdbHttp;

class	SdbCtl
{
public:
	enum	CtlCmd
	{
		CMD_NOTHING     ,
		CMD_HELP        ,
		CMD_SHOW        ,
		CMD_DB_CREATE   ,
		CMD_DB_DROP     ,
		CMD_DEV_ADD     ,
		CMD_DEV_DEL     ,
		CMD_LOADCSV     ,
		CMD_SMART_UPDATE,
		CMD_WATCH       ,
	};

	enum	ConsoleColumn
	{
		COLUMN1            = 38,
		COLUMN2            = 49,
		COLUMN3            = 60,
		COLUMN_MAX         = 80,
	};
	enum	PostMode
	{
		POSTMODE_DB  ,
		POSTMODE_HTTP,
	};

	SdbLib *		sdblib;
	SdbHttp *		sdbhttp;

	SQPath			progPath;
	SQPath			progDir;
	SQPath			defFile;

	struct opt_tag
	{
		PostMode	postmode;
		int			random_wait_sec;
		BOOL		smart;
		SQStr		csvfile;
	} opt;

public:
	SdbCtl();
	~SdbCtl();

	int			Init(void);
	int			LoadDef(void);
	int			CommandLine(int argc, const TCHAR ** argv);

	int			CreateDatabase(void);
	int			DropDatabase(void);
	int			DeviceWork(CtlCmd cmd);
	int			DeviceWork(CtlCmd cmd, SdbDev * dev);
	void		PrintSmart(SdbDev * dev);
	int			AddDevice(SdbDev * dev);
	int			RemoveDevice(SdbDev * dev);
	int			SmartUpdate(SdbDev * dev);
	int			LoadCsv(SdbDev * dev);
	int			WatchSmartDatabase(void);
	static void		PutPos(int pos, ... );
};

extern SdbCtl	sdbctl;

#endif
